﻿Imports C1.WPF.C1Chart

Class MainWindow

    Private Sub HighLowOpenCloseSeries_PlotElementLoaded(sender As System.Object, e As System.EventArgs)
        Dim pe As PlotElement = CType(sender, PlotElement)

        ' Retrieve the values of the Candle Element
        Dim open As Double = CType(pe.DataPoint("OpenValues"), Double)
        Dim close As Double = CType(pe.DataPoint("CloseValues"), Double)
        Dim low As Double = CType(pe.DataPoint("LowValues"), Double)
        Dim high As Double = CType(pe.DataPoint("HighValues"), Double)

        ' Declare a new Rect element to replace the original PlotElement
        Dim rect As Rectangle = New Rectangle()
        ' Get the region of the Current PlotElement
        Dim rct As Rect = ((CType((pe), System.Windows.Shapes.Shape)).RenderedGeometry).Bounds

        ' Get the Parent Container of the PlotElements
        Dim cvs As Canvas = CType(pe.Parent, Canvas)
        ' Add the new Rectangle to the Parent Container
        cvs.Children.Add(rect)

        ' Retrieve the Chart Coordinates based on the High/Low and Open/Close values
        ' These points are used to position the new Rectangle
        Dim openPoint As Point = c1Chart1.View.AxisX.PointFromData(New Point(pe.DataPoint.PointIndex + 1, open))
        Dim closePoint As Point = c1Chart1.View.AxisX.PointFromData(New Point(pe.DataPoint.PointIndex + 1, close))

        Dim lowPoint As Point = c1Chart1.View.AxisX.PointFromData(New Point(pe.DataPoint.PointIndex + 1, low))
        Dim HighPoint As Point = c1Chart1.View.AxisX.PointFromData(New Point(pe.DataPoint.PointIndex + 1, high))

        Canvas.SetLeft(rect, closePoint.X - (rct.Width / 2))
        rect.Width = rct.Width
        rect.Height = lowPoint.Y - closePoint.Y

        ' For Positive Candle Values
        If close > open Then
            Canvas.SetTop(rect, closePoint.Y - 1)
            rect.Fill = Brushes.GreenYellow
        Else ' For Negative Candle Values
            Canvas.SetTop(rect, openPoint.Y - 1)
            rect.Fill = Brushes.Red
        End If

        ' Add Line for marking Low/High Points (Candle Wick)
        Dim ln As Line = New Line()
        ln.StrokeThickness = 1
        ln.Stroke = New SolidColorBrush(Colors.Blue)
        ln.X1 = lowPoint.X
        ln.Y1 = lowPoint.Y
        ln.X2 = HighPoint.X
        ln.Y2 = HighPoint.Y
        cvs.Children.Add(ln)

        ' Set Z index for Candle to bring Close/Open rectangel on top of the Low/High Line
        Canvas.SetZIndex(rect, 1)

        ' Remove the original PlotElement
        cvs.Children.Remove(pe)
    End Sub
End Class
